'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isPlainObject = require('lodash/isPlainObject');

var _isPlainObject2 = _interopRequireDefault(_isPlainObject);

var _mergeWith = require('lodash/mergeWith');

var _mergeWith2 = _interopRequireDefault(_mergeWith);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; } /* eslint-disable class-methods-use-this */


let Base = class Base {
  // eslint-disable-next-line no-unused-vars
  has(key) {
    throw new Error('Not implemented!');
  }

  // eslint-disable-next-line no-unused-vars
  getBackendValue(key) {
    throw new Error('Not implemented!');
  }

  get(key, nextStore) {
    var _this = this;

    return _asyncToGenerator(function* () {
      if (!_this.has(key)) {
        return nextStore.get(key);
      }

      const value = yield _this.getBackendValue(key);

      if (!_this.isMergeable(value)) {
        return value;
      }

      const nextValue = yield nextStore.get(key);

      if (value !== undefined && !_this.isMergeable(nextValue)) {
        return value;
      }

      return _this.merge(nextValue, value);
    })();
  }

  isMergeable(value) {
    return Array.isArray(value) || (0, _isPlainObject2.default)(value);
  }

  merge(src1, src2) {
    // eslint-disable-next-line consistent-return
    return (0, _mergeWith2.default)({}, src1, src2, (val1, val2) => {
      if (Array.isArray(val1) && Array.isArray(val2)) {
        return [...val1, ...val2];
      }
    });
  }
};
exports.default = Base;