'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _isEmpty = require('lodash/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _Base = require('./Base');

var _Base2 = _interopRequireDefault(_Base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

let EnvStore = (_temp = _class = class EnvStore extends _Base2.default {

  constructor(prefix) {
    super();
    this.prefix = prefix;
    this.backend = process.env;
    this.keys = Object.keys(this.backend);
  }

  has(key) {
    return this.keys.includes(EnvStore.makeKey(this.prefix, key));
  }

  getBackendValue(key) {
    const value = this.backend[EnvStore.makeKey(this.prefix, key)];

    try {
      return JSON.parse(value);
    } catch (err) {
      return value;
    }
  }

  get(key, nextStore) {
    var _this = this;

    return _asyncToGenerator(function* () {
      const value = yield _Base2.default.prototype.get.call(_this, key, nextStore);
      const deepValue = _this.getDeep(key, value);

      if (!_this.has(key) && !(0, _isEmpty2.default)(deepValue)) {
        return _this.merge(value, deepValue);
      }

      return value;
    })();
  }

  getDeep(prefix, value) {
    return Object.keys(value).reduce((acc, key) => {
      const fullKey = `${prefix}.${key}`;

      if (this.has(fullKey)) {
        return _extends({}, acc, {
          [key]: this.getBackendValue(fullKey)
        });
      }

      if (_lodash2.default.isPlainObject(value[key])) {
        return _extends({}, acc, {
          [key]: this.getDeep(fullKey, value[key])
        });
      }

      return acc;
    }, {});
  }
}, _class.makeKey = (prefix, key) => {
  const path = _lodash2.default.toPath(key);
  const finalPath = path.map(item => _lodash2.default.toUpper(_lodash2.default.snakeCase(item))).join('_');
  return prefix ? `${prefix}_${finalPath}` : finalPath;
}, _temp);
exports.default = EnvStore;