'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _Base = require('./Base');

var _Base2 = _interopRequireDefault(_Base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let MemoryStore = class MemoryStore extends _Base2.default {
  constructor(backend = {}) {
    super();
    this.backend = backend;
  }

  has(key) {
    return _lodash2.default.has(this.backend, key);
  }

  getBackendValue(key) {
    return _lodash2.default.get(this.backend, key);
  }

  set(key, value) {
    _lodash2.default.set(this.backend, key, value);
    return this;
  }

  add(data) {
    _lodash2.default.merge(this.backend, data);
    return this;
  }

  unset(key) {
    _lodash2.default.unset(this.backend, key);
    return this;
  }
};
exports.default = MemoryStore;